from src.batch.ultmarc.utmp_tables.table_mapper.ultmarc_table_mapper import \
    UltmarcTableMapper
from src.batch.ultmarc.utmp_tables.tables.com_dr_sosiety import ComDrSosiety


class ComDrSosietyMapper(UltmarcTableMapper):
    """レイアウト区分521: COM_所属学会 登録処理"""

    # レコード存在確認SQL
    RECORD_EXISTS_QUERY = """\
    SELECT
        COUNT(*) AS count_num
    FROM
        src05.com_dr_sosiety
    WHERE
        sosiety_cd = :sosiety_cd
        AND
        dcf_pcf_dr_cd = :dcf_pcf_dr_cd
    """
    # データ登録用SQL
    INSERT_QUERY = """\
    INSERT INTO src05.com_dr_sosiety
    (
        sosiety_cd,
        dcf_pcf_dr_cd,
        sosiety_f,
        regist_ymd,
        sys_regist_date,
        regist_prgm_id,
        sys_update_date,
        update_prgm_id
    )
    VALUES (
        :sosiety_cd,
        :dcf_pcf_dr_cd,
        :sosiety_f,
        :execute_date_str_ymd,
        :execute_datetime,
        :program_name,
        :execute_datetime,
        :program_name
    )
    """

    UPDATE_QUERY = """\
    UPDATE
        src05.com_dr_sosiety
    SET
        sosiety_f = :sosiety_f,
        update_ymd = :execute_date_str_ymd,
        sys_update_date = :execute_datetime,
        update_prgm_id = :program_name
    WHERE
        sosiety_cd = :sosiety_cd
        AND
        dcf_pcf_dr_cd = :dcf_pcf_dr_cd
    """

    # 削除『修正区分がB(修正)かつ追加削除区分が1(退職)』SQL
    PHYSICAL_DELETE_QUERY = """\
    DELETE FROM
        src05.com_dr_sosiety
    WHERE
        sosiety_cd = :sosiety_cd
        AND
        dcf_pcf_dr_cd = :dcf_pcf_dr_cd
    """

    record: ComDrSosiety

    def __init__(self, record: list[str], db) -> None:
        super().__init__(record, db, ComDrSosiety)
        program_name = __name__.split('.')[-1]  # 当モジュール名(現行から変わっている)
        # モジュール名をクエリパラメータに設定
        self.query_parameter['program_name'] = program_name
        # 読み込んだレコード値もクエリパラメータに追加
        self.query_parameter = {**self.query_parameter, **self.record.to_sql_parameter()}

    def make_query(self):
        # 削除『修正区分がB(修正)かつ追加削除区分が1(退職)』
        if self.record.maint_flag == 'B' and self.record.cont_flag == '1':
            self.queries.append(self.PHYSICAL_DELETE_QUERY)
            return

        # 追加、更新の場合
        self.queries.append(self.__make_upsert_query())
        return

    def __make_upsert_query(self):
        # レコードの存在確認
        record_count = self.db.execute_select(self.RECORD_EXISTS_QUERY, self.query_parameter)
        # 存在しない場合はInsert
        if record_count[0]['count_num'] == 0:
            return self.INSERT_QUERY

        # 存在する場合ではUpdate
        return self.UPDATE_QUERY
